DECLARE SUB dots ()
DECLARE SUB tunnel ()
DECLARE SUB net ()
DECLARE SUB worm ()
DECLARE SUB strings ()
DECLARE SUB blocks ()
DEFINT A-Z
DIM SHARED keypressed$
kepressed$ = ""
RANDOMIZE TIMER
numshows = 5
current.show = INT(RND * numshows)
DO
    SELECT CASE current.show
        CASE 0: net
        CASE 1: strings
        CASE 2: tunnel
        CASE 3: worm
        CASE 4: dots
    END SELECT
    SELECT CASE keypressed$
        CASE ""
        CASE CHR$(9)
            current.show = (current.show + 1) MOD numshows
        CASE ELSE
            done = 1
    END SELECT
LOOP UNTIL done = 1
SCREEN 12
SCREEN 0

SUB blocks
    CONST chunknum = 10
    DIM chunk(300), chunkx(chunknum), chunky(chunknum)
    DIM chunkxi(chunknum), chunkyi(chunknum)
    DIM chunkxii(chunknum), chunkyii(chunknum)
    RANDOMIZE TIMER
    SCREEN 13: CLS
    FOR n = 0 TO 7
        LINE (n, n)-(15 - n, 15 - n), n + 50, BF
    NEXT n
    GET (0, 0)-(15, 15), chunk
    PUT (0, 0), chunk
    FOR n = 1 TO chunknum
        chunkx(n) = RND * 280 + 20
        chunky(n) = RND * 160 + 14
        IF RND < .5 THEN
            chunkyi(n) = 0
            IF RND < .5 THEN
                chunkxi(n) = -2
                chunkxii(n) = 1
            ELSE
                chunkxi(n) = 2
                chunkxii(n) = -1
            END IF
        ELSE
            chunkxi(n) = 0
            IF RND < .5 THEN
                chunkyi(n) = -2
                chunkyii(n) = 1
            ELSE
                chunkyi(n) = 2
                chunkyii(n) = -1
            END IF
        END IF
    NEXT n

    FOR n = 1 TO chunknum
        PUT (chunkx(n), chunky(n)), chunk
    NEXT n
    DO

        FOR n = 1 TO chunknum
       
            LINE (chunkx(n), chunky(n))-(chunkx(n) + chunk(0) - 1, chunky(n) + chunk(1) - 1), 0, BF
            chunkxi(n) = chunkxi(n) + chunkxii(n)
            chunkyi(n) = chunkyi(n) + chunkyii(n)
            IF chunkx(n) + chunkxi(n) < 15 OR chunkx(n) + chunkxi(n) > 300 THEN chunkxi(n) = -chunkxi(n) + chunkxii(n)
            IF chunky(n) + chunkyi(n) < 10 OR chunky(n) + chunkyi(n) > 180 THEN chunkyi(n) = -chunkyi(n) + chunkyii(n)
            chunkx(n) = chunkx(n) + chunkxi(n)
            chunky(n) = chunky(n) + chunkyi(n)
            IF n MOD 2 = 0 THEN
                PUT (chunkx(n), chunky(n)), chunk, PSET
            ELSE
                PUT (chunkx(n), chunky(n)), chunk, PRESET
            END IF
        NEXT n
        WHILE t! = TIMER: WEND
        t! = TIMER
        keypressed$ = INKEY$
    LOOP UNTIL keypressed$ <> ""
END SUB

SUB dots
    CONST numdots = 100
    DIM x(numdots), y(numdots), z(numdots)
    SCREEN 13: CLS
    FOR n = 1 TO numdots
        x(n) = RND * 319
        y(n) = RND * 199
        z(n) = INT(RND * 15) + 16
    NEXT n
    DO
        FOR n = 1 TO numdots
            PSET (x(n), y(n)), 0
            y(n) = y(n) + 1
            x(n) = (x(n) + 10 - ABS(100 - y(n)) / 10) MOD 320
            
            IF y(n) > 199 THEN
                x(n) = RND * 320
                y(n) = 0
                z(n) = INT(RND * 15) + 16
            END IF
            PSET (x(n), y(n)), z(n)

        NEXT n
        WHILE t! = TIMER: WEND
        t! = TIMER

        keypressed$ = INKEY$
    LOOP UNTIL keypressed$ <> ""

END SUB

SUB net
    RANDOMIZE TIMER
    SCREEN 13: CLS
    CONST numballs = 12
    DIM x(numballs), y(numballs), xi(numballs), yi(numballs), yii(numballs)
    DIM xii(numballs), oldx(numballs), oldy(numballs), colour(numballs)
   
    FOR n = 1 TO numballs
        colour(n) = 32 + n
        x(n) = INT(RND * 50) + 100
        y(n) = RND * 50 + 20
        yii(n) = (RND * 2) + 1
        xii(n) = (RND * 3) + 1
        xi(n) = INT(RND * 5) + 1
        IF RND < .5 THEN xi(n) = -xi(n)
    NEXT n


    DO
        WHILE t! = TIMER: WEND
        t! = TIMER

        FOR n = 1 TO numballs - 1
            LINE (oldx(n), oldy(n))-(oldx(n + 1), oldy(n + 1)), 0
            LINE (oldx(n), 200 - oldy(n))-(oldx(n + 1), 200 - oldy(n + 1)), 0
            LINE (320 - oldx(n), oldy(n))-(320 - oldx(n + 1), oldy(n + 1)), 0
            LINE (320 - oldx(n), 200 - oldy(n))-(320 - oldx(n + 1), 200 - oldy(n + 1)), 0
        
            LINE (x(n), y(n))-(x(n + 1), y(n + 1)), colour(n)
            LINE (x(n), 200 - y(n))-(x(n + 1), 200 - y(n + 1)), colour(n)
            LINE (320 - x(n), y(n))-(320 - x(n + 1), y(n + 1)), colour(n)
            LINE (320 - x(n), 200 - y(n))-(320 - x(n + 1), 200 - y(n + 1)), colour(n)
        
            oldx(n) = x(n)
            oldy(n) = y(n)
        NEXT n
        oldx(numballs) = x(numballs)
        oldy(numballs) = y(numballs)

        'FOR n = 1 TO 2000: NEXT n
        FOR n = 1 TO numballs
            x(n) = x(n) + xi(n) / 2
            y(n) = y(n) + yi(n) / 2
        
            yi(n) = yi(n) + yii(n)
            xi(n) = xi(n) + xii(n)
        
            IF x(n) + xi(n) > 170 THEN
                xi(n) = -(xi(n))
                xii(n) = 1
            ELSEIF x(n) + xi(n) < 0 THEN
                xi(n) = -(xi(n))
                xii(n) = -1
            END IF
        
            IF y(n) + yi(n) < 0 THEN
                yi(n) = -(yi(n))
                yii(n) = -1
            ELSEIF y(n) + yi(n) > 110 THEN
                yi(n) = -(yi(n))
                yii(n) = 1
            END IF
        NEXT n
        keypressed$ = INKEY$
    LOOP UNTIL keypressed$ <> ""
END SUB

SUB polygon (x, y, sides, radius, angle!, colour)
   
    ix = SIN(angle! - ((2 * pi) / sides)) * radius
    iy = COS(angle! - ((2 * pi) / sides)) * radius
    x2 = ix
    y2 = iy
    FOR a! = angle! - (2 * pi) / sides TO angle! + 2 * pi STEP (2 * pi) / sides
        x2 = x1
        y2 = y1
        x1 = SIN(a!) * radius
        y1 = COS(a!) * radius
        IF doneonce = 0 THEN
            doneonce = 1
            x2 = x1
            y2 = y1
        END IF
        LINE (x1 + x, y1 + y)-(x2 + x, y2 + y), colour
    NEXT a!
END SUB

SUB strings
    CONST numpoints = 24, numworms = 3
    DIM x(numworms, numpoints), y(numworms, numpoints), xi(numworms), yi(numworms)
    '================================= Misc.
    SCREEN 13: CLS
    FOR m = 0 TO numworms - 1
        r! = RND
        g! = RND
        B! = RND
        FOR n = 1 TO numpoints
            PALETTE n + m * 64, INT(r! * n) * INT(63 / numpoints) + 256 * INT(g! * n) * INT(63 / numpoints) + 65536 * INT(B! * n) * INT(63 / numpoints)
        NEXT n
        xi(m) = 5 * (m + 1)
   NEXT m

    yii = 1
    '================================= Main function
    DO
        FOR m = 0 TO numworms - 1
            FOR n = numpoints - 1 TO 0 STEP -1
                LINE (x(m, n), y(m, n))-(x(m, n + 1), y(m, n + 1)), 0
                LINE (319 - x(m, n), 199 - y(m, n))-(319 - x(m, n + 1), 199 - y(m, n + 1)), 0
            NEXT n
            IF x(m, numpoints) + xi(m) > 320 OR x(m, numpoints) + xi(m) < 0 THEN xi(m) = -xi(m)
            IF y(m, numpoints) + yi(m) > 200 OR y(m, numpoints) + yi(m) < 0 THEN yi(m) = -yi(m) - yii
            IF RND < .07 THEN yii = -yii
            IF RND < .07 THEN xii = -xii
            IF (ABS(yi(m)) > 10) AND (SGN(yi(m)) = SGN(yii)) THEN yii = -yii
            IF (ABS(xi(m)) > 10) AND (SGN(xi(m)) = SGN(xii)) THEN xii = -xii
            yi(m) = yi(m) + yii
            x(m, numpoints) = x(m, numpoints) + xi(m)
            y(m, numpoints) = y(m, numpoints) + yi(m)
            FOR n = numpoints - 1 TO 0 STEP -1
                x(m, n) = (x(m, n) + x(m, n + 1)) / 2
                y(m, n) = (y(m, n) + y(m, n + 1)) / 2
                LINE (x(m, n), y(m, n))-(x(m, n + 1), y(m, n + 1)), n + 1 + 64 * m
                LINE (319 - x(m, n), 199 - y(m, n))-(319 - x(m, n + 1), 199 - y(m, n + 1)), n + 1 + 64 * m
            NEXT n
        NEXT m
        keypressed$ = INKEY$
        WHILE t! = TIMER: WEND
        t! = TIMER
    LOOP UNTIL keypressed$ <> ""
END SUB

SUB tunnel
    CONST growth = 1.05
    DIM x(500), y(500), z(500)  AS SINGLE, c(500)
    SCREEN 13: CLS
    z(0) = 10
    x(0) = 160
    y(0) = 100
    radi = 1
    radius = 20
    DO
        WHILE t! = TIMER: WEND
        t! = TIMER
        radius = radius + radi
        IF radius > 100 OR radius < 20 THEN radi = -radi
        IF z(numcircles) > 11 THEN
            a! = a! + .025
            numcircles = numcircles + 1
            x(numcircles) = 160 + SIN(a!) * radius + COS(a!) / radius
            y(numcircles) = 100 + COS(a!) * radius + SIN(a!) / radius
            z(numcircles) = 10
            colour = (colour + 1) MOD 32 + 32
            c(numcircles) = colour

        END IF

        FOR n = numcircles TO 0 STEP -1
            'LINE (x(n) - z(n) * 1.2, y(n) - z(n))-(x(n) + z(n) * 1.2, y(n) + z(n)), 0, B
            CIRCLE (x(n), y(n)), z(n), 0
            z(n) = z(n) * growth
            IF z(n) < 300 THEN
                'LINE (x(n) - z(n) * 1.2, y(n) - z(n))-(x(n) + z(n) * 1.2, y(n) + z(n)), c(n), B
                 CIRCLE (x(n), y(n)), z(n), c(n)
            ELSE
                FOR a = n TO numcircles - 1
                    x(a) = x(a + 1)
                    y(a) = y(a + 1)
                    z(a) = z(a + 1)
                    c(a) = c(a + 1)
                NEXT a
                numcircles = numcircles - 1
            END IF
        NEXT n
        keypressed$ = INKEY$
    LOOP UNTIL keypressed$ <> ""
END SUB

SUB worm
    DIM oldyi(40), oldx(40), oldy(40)
    SCREEN 12: CLS

    '=========== The appropriate equation for fiddling with the vga, mcga palette:
    ' palette index, [0-63 {red}] + [256*(0-63) {green}] + [65536*(0-64) {blue}]
    ' of course, there is no specific order in which these must go

    FOR n = 1 TO 15
        PALETTE n, n * 3 + 256 * (64 - (n * 3)) + 65536 * (64 - n)
    NEXT n
    x = 320
    y = 200
    xi = 8
    yi = 20
    yii = 1
    xii = 1
    DO
        WHILE t! = TIMER: WEND
        t! = TIMER
        '============================= handle the creation of x, y
        x = x + xi
        y = y + yi
        xi = xi + xii
        yi = yi + yii
        IF x + xi > 640 OR RND < .02 OR x + xi < 0 THEN xi = -xi: IF xi <> 0 THEN xii = -SGN(xi)
        IF y + yi > 480 OR y + yi < 0 OR RND < .02 THEN yi = -(yi - yii): IF yi <> 0 THEN yii = -SGN(yi)
        '============================= cycle animation
        FOR n = 40 TO 2 STEP -1
            shift = 20 - ABS(20 - n)
            IF n > 20 THEN LINE (oldx(n) - shift, oldy(n) - shift)-(oldx(n) + shift, oldy(n) + shift), 0, B
            oldx(n) = oldx(n - 1)
            oldy(n) = oldy(n - 1)
            IF n < 20 THEN LINE (oldx(n) - shift, oldy(n) - shift)-(oldx(n) + shift, oldy(n) + shift), n, B
        NEXT n
        oldx(1) = x
        oldy(1) = y
        keypressed$ = INKEY$
    LOOP UNTIL keypressed$ <> ""
END SUB

